



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>前端模块化工具--webpack使用感受</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">前端模块化工具--webpack使用感受</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-06 18:32:44 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>话说前头</h2>
<ul><li><p>webpack前段时间有听说一下，现在已经到了3.x的版本，自己没去接触。因为之前使用gulp来作为自己的项目构建工具。现在感觉gulp使用的趋势在减少。现在这段时间去接触了webpack，感觉很不错，它的模块化打包机制，对前端开发和性能方面都带来好处。这里不是说gulp不好，两者不作比较</p></li>
<li><p>接下来会说说自己对webpack使用的感受，我不会一步步写出使用webpack的流程，因为关于webpack的教程有很多，但会写一些关键地方，注意地方，来加深对webpack的见解。</p></li>
<li><p>学习就是这样，东看看西看看，看人家的对某件东西的见解，加上自己的理解，是否异同，慢慢积累，最终成为自己的知识。</p></li></ul>
<h2>webpack介绍</h2>
<h3>1.（引用了webpack官网的一句话）：</h3>
<blockquote><p>webpack 是一个现代 JavaScript 应用程序的模块打包器(module bundler)。当 webpack 处理应用程序时，它会递归地构建一个依赖关系图(dependency graph)，其中包含应用程序需要的每个模块，然后将所有这些模块打包成少量的 bundle - 通常只有一个，由浏览器加载。<br /><br />
它是高度可配置的，但是，在开始前你需要先理解四个核心概念：入口(entry)、输出(output)、loader、插件(plugins)。</p></blockquote>
<h3>2.个人理解：</h3>
<p>这里说了这么多就是它能把项目中资源文件看成一个个模块，然后将他们打包成少量或一个文件，然后我们去引用这文件。</p>
<h3>3.疑惑：</h3>
<p>大家这里可能会疑惑，当时我也想，怎么能做到这个？怎么就打包成一个文件了？那么js，css，图片什么的怎么搞？还有这种操作？我能怎么办，那只能选择相信它。</p>
<h3>4.感受：</h3>
<p>其实学习某一样工具，我们只需要知道这东西能做什么，然后怎么用它，但它具体实现的细节，有时我们不必深究。我们只需知其然，不必知其所以然。尽管去用这个东西，它本来就是一个工具。就好比开一辆车，我们只需去学习怎么开，而不用太在意他为什么能开，开多了一样成为老司机，不是吗，没毛病吧。工具它能给我们带来便利，就足够了。除非你是制造工具的。但是如果对webpack非常感兴趣，可以去它的github上看看。</p>
<h2>webpack能做的事：</h2>
<p>上面说webpack能打包模块，其实还有很多功能。</p>
<ul><li>webpack可以对Js进行转译，当前浏览器很多不支持es6，但是我们想使用es6的语法，webpack可以将es6语法转成es5语法</li>
<li>webpack可以对less，sass，stylus等css的预处理语言进行转译</li>
<li>webpack可以热更新</li>
<li>webpack可以对图片处理，压缩，转成base64格式。</li>
<li>webpack可以对代码进行压缩。</li>
<li>webpack可以进行语法检查，可以生成自动化html模板等等</li></ul>
<p>上面举例是常用，其功能还多得多。都是通过webpack 的 loader和plugins实现的，可以说是很强大了。</p>
<h2>webpack安装：</h2>
<ol><li>前提有nodejs和npm，在网上搜索安装，现在的nodejs都会带有npm，所以直接安装nodejs即可。</li>
<li>通过 cmd（用的是win操作系统）运行：node -v 和 npm -v 若都能返回版本号表明安装成功。</li>
<li>接着正式安装webpack,命令行中运行：</li></ol>
<pre class="prettyprint linenums"><code>//全局安装<br />
npm install -g webpack<br />
//创建一个文件夹<br />
mkdir webpack-demo<br />
//进入项目中<br />
cd webpack-demo<br />
//初始化，生成默认package.json 文件<br />
npm init -y<br />
//在当前项目中安装webpack<br />
npm install webpack --save-dev<br />
//到这里就安装成功了<br />
</code></pre>
<blockquote><p>感受：整个流程和安装gulp差不多，是npm模块的那套安装流程。<br /><br />
说到npm，在国内推荐使用cnpm淘宝镜像，很不错，速度快很多。还有可以逛npm的官网去查询自己想要看的模块，里面都有模块的详细介绍。</p></blockquote>
<h2>webpack的关键文件:webpack.config.js</h2>
<ul><li>webpack.config.js是webpack的配置文件，对项目中的webpack进行配置。</li>
<li>文件中用到的插件和loader需要先试用npm安装好：</li></ul>
<pre class="prettyprint linenums"><code>// 安装css-loader<br />
npm install css-loader  --save-dev<br />
// 安装htmlWebpackPlugin<br />
npm install html-webpack-plugin --save-dev<br />
</code></pre>
<ul><li>项目根目录新建简单的webpack.config.js文件：</li></ul>
<pre class="prettyprint linenums"><code>//引入模块<br />
const webpack = require('webpack');<br />
const path = require('path');<br />
const htmlWebpackPlugin = require('html-webpack-plugin');<br />
//配置<br />
const config = {<br />
  entry: './path/to/my/entry/file.js',<br />
  output: {<br />
    path: path.resolve(__dirname, 'dist'),<br />
    filename: 'my-first-webpack.bundle.js'<br />
  },<br />
  module: {<br />
    rules: [<br />
      { test: /\.css$/, use: 'css-loader' }<br />
    ]<br />
  },<br />
  plugins: [<br />
    new HtmlWebpackPlugin({template: './src/index.html'})<br />
  ]<br />
};<br />
</code></pre>
<ul><li><p>这个文件中关键的东西就是上述提到的：四个核心概念：入口(entry)、输出(output)、loader、插件(plugins)。弄懂这四个核心的东西，webpack也就懂得差不多了，起码懂得怎么用。</p></li>
<li><p>各大核心的作用：</p></li></ul>
<ol><li>entry： 入口文件，也就是想要被打包的文件，这里可以是一个或者多个。</li>
<li>output： 输入文件，表示打包后的文件将会被输出到哪里，可以一个或多个。</li>
<li>module：模块，里面的rules是一个数组，存放则项目中需要用到的loader，loader可以对资源文件进行一系列的处理。常见的loader：style-loader，css-loader，less-loader，babel-loader，url-loader等等。</li>
<li>plugins：插件，为webpack添加所需的功能，如例子里面的是自动生成html模板插件。<br /><br />
更多细节在webpack的官网上查看。</li></ol>
<h2>最后再说说：</h2>
<ul><li>本次文章主要说说自己使用webpack时的一些想法和收获，可能写得不是很好，但这是个学习的过程，我很享受。</li>
<li>再提提，以前我不怎么喜欢去看一些官方的文档，因为全都是英文，自己英语也不是很好。但是后来硬着头皮看，发现在文档中学到的东西很多，也更有助于理解，有的文档写得很详细，会懂得很多。这过程中不会的英语单词就去查，顺便就补补英语，其实挺好。通过自己看文档，然后能用，能做，心里美滋滋。</li></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m96l4n94.html">【JavaScript吉光片羽】遭遇IE8</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv2exx9.html">剑指Offer面试题：32&period;数字在排序数组中出现的次数</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyrmex8.html">aspjpeg 组件在asp中的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/49ggk2l9.html">hdu4607 Park Visit（树的直径）</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g75n09.html">sql Server中SET QUOTED&lowbar;IDENTIFIER的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qn3ejj9.html">Azure DocumentDB对比MongoDB</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1p6j69.html">css 属性积累</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wxjroq.html">GameMap地图初始化</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okw4p59.html">RS485接线 - 为什么要给2线制RS485接3根线？</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdl2rd8.html">iOS 集成支付宝遇到的问题&lpar;续&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yvwnnq.html">Swoole源代码学习记录（十五）&mdash;&mdash;Timer模块分析</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdxoym8.html">UNIX网络编程--IPV4 IPV6 ICMPV4 ICMPV6</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z3xgn9.html">【机器学习】彻底搞懂CNN</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7z3w5k9.html">流API--原始类型流</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxk36ze8.html">windows代码&comma;传入文件名&comma;遍历此目录下所有文件&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvj0jg8.html">深度学习项目&mdash;&mdash;基于循环神经网络（RNN）的智能聊天机器人系统</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rzxko9.html">&commat;RequestMapping 和 &commat;GetMapping &commat;PostMapping 区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kxe4xq.html">VMware激活码，Acrobat激活码</a>
		</li>
						<li><a href="https://www.batexi.com/a/953nrr68.html">VBA笔记（一）&mdash;&mdash;基础配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvl3r2q.html">Appium測试安卓Launcher以滑动窗口获得目标应用</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qy15nejq.html">PHP数组简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1klxm59.html">侯捷STL学习&lpar;二&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpvzv39.html">【小练习05】HTML&plus;CSS--淘宝商铺小页面</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpzvnjq.html">Hybrid App开发之JavaScript基础</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpz4l7q.html">Java经典编程题50道之四十一</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jz245e8.html">File字节流</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojg6v1q.html">java原生实现屏幕设备遍历和屏幕采集（捕获）等功能</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mew0prq.html">Android界面&lpar;1&rpar;    使用TextView实现跑马灯效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/950wovv8.html">依赖注入之Autofac使用总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljk6509.html">Mac下终端配置（item2 &plus; oh-my-zsh &plus; solarized配色方案）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
